/*
 * Copyright (C) 2012, Nils Asmussen <nils@os.inf.tu-dresden.de>
 * Economic rights: Technische Universitaet Dresden (Germany)
 *
 * This file is part of NRE (NOVA runtime environment).
 *
 * NRE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * NRE is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License version 2 for more details.
 */

#include <stream/Serial.h>
#include <kobj/Pt.h>
#include <CPU.h>

using namespace nre;

PORTAL static void portal_echo(capsel_t) {
    UtcbFrameRef uf;
    int x;
    uf >> x;
    uf.finish_input();
    uf << x;
}

int main() {
    LocalThread *lt = LocalThread::create(CPU::current().log_id());
    Pt echo(lt, portal_echo);

    UtcbFrame uf;
    uf << 42;
    echo.call(uf);
    int res;
    uf >> res;

    Serial::get() << "Hello World: " << res << "\n";
    return 0;
}
